/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_DSAPublicKey(unsigned char *p, size_t len, const DSAPublicKey *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
e = der_put_heim_integer(p, len, data, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_DSAPublicKey(const unsigned char *p, size_t len, DSAPublicKey *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_Integer, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
e = der_get_heim_integer(p, len, data, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DSAPublicKey(data);
return e;
}

void
free_DSAPublicKey(DSAPublicKey *data)
{
der_free_heim_integer(data);
}

size_t
length_DSAPublicKey(const DSAPublicKey *data)
{
size_t ret = 0;
ret += der_length_heim_integer(data);
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_DSAPublicKey(const DSAPublicKey *from, DSAPublicKey *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_heim_integer(from, to)) goto fail;
return 0;
fail:
free_DSAPublicKey(to);
return ENOMEM;
}

