/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_DistributionPoint(unsigned char *p, size_t len, const DistributionPoint *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* cRLIssuer */
if((data)->cRLIssuer) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->cRLIssuer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 2, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* reasons */
if((data)->reasons) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->reasons, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* distributionPoint */
if((data)->distributionPoint) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->distributionPoint, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_DistributionPoint(const unsigned char *p, size_t len, DistributionPoint *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t distributionPoint_datalen, distributionPoint_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &distributionPoint_datalen, &l);
if(e) {
(data)->distributionPoint = NULL;
} else {
(data)->distributionPoint = calloc(1, sizeof(*(data)->distributionPoint));
if ((data)->distributionPoint == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
distributionPoint_oldlen = len;
if (distributionPoint_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = distributionPoint_datalen;
e = decode_heim_any(p, len, (data)->distributionPoint, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = distributionPoint_oldlen - distributionPoint_datalen;
}
}
{
size_t reasons_datalen, reasons_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &reasons_datalen, &l);
if(e) {
(data)->reasons = NULL;
} else {
(data)->reasons = calloc(1, sizeof(*(data)->reasons));
if ((data)->reasons == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
reasons_oldlen = len;
if (reasons_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = reasons_datalen;
e = decode_heim_any(p, len, (data)->reasons, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = reasons_oldlen - reasons_datalen;
}
}
{
size_t cRLIssuer_datalen, cRLIssuer_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 2, &cRLIssuer_datalen, &l);
if(e) {
(data)->cRLIssuer = NULL;
} else {
(data)->cRLIssuer = calloc(1, sizeof(*(data)->cRLIssuer));
if ((data)->cRLIssuer == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
cRLIssuer_oldlen = len;
if (cRLIssuer_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = cRLIssuer_datalen;
e = decode_heim_any(p, len, (data)->cRLIssuer, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = cRLIssuer_oldlen - cRLIssuer_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DistributionPoint(data);
return e;
}

void
free_DistributionPoint(DistributionPoint *data)
{
if((data)->distributionPoint) {
free_heim_any((data)->distributionPoint);
free((data)->distributionPoint);
(data)->distributionPoint = NULL;
}
if((data)->reasons) {
free_heim_any((data)->reasons);
free((data)->reasons);
(data)->reasons = NULL;
}
if((data)->cRLIssuer) {
free_heim_any((data)->cRLIssuer);
free((data)->cRLIssuer);
(data)->cRLIssuer = NULL;
}
}

size_t
length_DistributionPoint(const DistributionPoint *data)
{
size_t ret = 0;
if((data)->distributionPoint){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->distributionPoint);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->reasons){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->reasons);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->cRLIssuer){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->cRLIssuer);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_DistributionPoint(const DistributionPoint *from, DistributionPoint *to)
{
memset(to, 0, sizeof(*to));
if((from)->distributionPoint) {
(to)->distributionPoint = malloc(sizeof(*(to)->distributionPoint));
if((to)->distributionPoint == NULL) goto fail;
if(copy_heim_any((from)->distributionPoint, (to)->distributionPoint)) goto fail;
}else
(to)->distributionPoint = NULL;
if((from)->reasons) {
(to)->reasons = malloc(sizeof(*(to)->reasons));
if((to)->reasons == NULL) goto fail;
if(copy_heim_any((from)->reasons, (to)->reasons)) goto fail;
}else
(to)->reasons = NULL;
if((from)->cRLIssuer) {
(to)->cRLIssuer = malloc(sizeof(*(to)->cRLIssuer));
if((to)->cRLIssuer == NULL) goto fail;
if(copy_heim_any((from)->cRLIssuer, (to)->cRLIssuer)) goto fail;
}else
(to)->cRLIssuer = NULL;
return 0;
fail:
free_DistributionPoint(to);
return ENOMEM;
}

