/* Generated from ./kx509.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <kx509_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_Kx509Request(unsigned char *p, size_t len, const Kx509Request *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* pk-key */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->pk_key, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* pk-hash */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->pk_hash, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* authenticator */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->authenticator, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_Kx509Request(const unsigned char *p, size_t len, Kx509Request *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t authenticator_datalen, authenticator_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_OctetString, &authenticator_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
authenticator_oldlen = len;
if (authenticator_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = authenticator_datalen;
e = der_get_octet_string(p, len, &(data)->authenticator, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = authenticator_oldlen - authenticator_datalen;
}
{
size_t pk_hash_datalen, pk_hash_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_OctetString, &pk_hash_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
pk_hash_oldlen = len;
if (pk_hash_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = pk_hash_datalen;
e = der_get_octet_string(p, len, &(data)->pk_hash, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = pk_hash_oldlen - pk_hash_datalen;
}
{
size_t pk_key_datalen, pk_key_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_OctetString, &pk_key_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
pk_key_oldlen = len;
if (pk_key_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = pk_key_datalen;
e = der_get_octet_string(p, len, &(data)->pk_key, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = pk_key_oldlen - pk_key_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_Kx509Request(data);
return e;
}

void
free_Kx509Request(Kx509Request *data)
{
der_free_octet_string(&(data)->authenticator);
der_free_octet_string(&(data)->pk_hash);
der_free_octet_string(&(data)->pk_key);
}

size_t
length_Kx509Request(const Kx509Request *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->authenticator);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->pk_hash);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->pk_key);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_Kx509Request(const Kx509Request *from, Kx509Request *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_octet_string(&(from)->authenticator, &(to)->authenticator)) goto fail;
if(der_copy_octet_string(&(from)->pk_hash, &(to)->pk_hash)) goto fail;
if(der_copy_octet_string(&(from)->pk_key, &(to)->pk_key)) goto fail;
return 0;
fail:
free_Kx509Request(to);
return ENOMEM;
}

