/* Generated from ./CMS.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_OriginatorInfo(unsigned char *p, size_t len, const OriginatorInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* crls */
if((data)->crls) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->crls, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* certs */
if((data)->certs) {
size_t Top_tag_oldret = ret;
ret = 0;
{
struct heim_octet_string *val;
size_t elen, totallen = 0;
int eret;
if (((data)->certs)->len > UINT_MAX/sizeof(val[0]))
return ERANGE;
val = malloc(sizeof(val[0]) * ((data)->certs)->len);
if (val == NULL && ((data)->certs)->len != 0) return ENOMEM;
for(i = 0; i < ((data)->certs)->len; i++) {
ASN1_MALLOC_ENCODE(heim_any, val[i].data, val[i].length, &((data)->certs)->val[i], &elen, eret);
if(eret) {
i--;
while (i >= 0) {
free(val[i].data);
i--;
}
free(val);
return eret;
}
totallen += elen;
}
if (totallen > len) {
for (i = 0; i < ((data)->certs)->len; i++) {
free(val[i].data);
}
free(val);
return ASN1_OVERFLOW;
}
qsort(val, ((data)->certs)->len, sizeof(val[0]), _heim_der_set_sort);
for(i = ((data)->certs)->len - 1; i >= 0; --i) {
p -= val[i].length;
ret += val[i].length;
memcpy(p + 1, val[i].data, val[i].length);
free(val[i].data);
}
free(val);
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_OriginatorInfo(const unsigned char *p, size_t len, OriginatorInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t certs_datalen, certs_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &certs_datalen, &l);
if(e) {
(data)->certs = NULL;
} else {
(data)->certs = calloc(1, sizeof(*(data)->certs));
if ((data)->certs == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
certs_oldlen = len;
if (certs_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = certs_datalen;
{
size_t certs_Tag_origlen = len;
size_t certs_Tag_oldret = ret;
size_t certs_Tag_olen = 0;
void *certs_Tag_tmp;
ret = 0;
((data)->certs)->len = 0;
((data)->certs)->val = NULL;
while(ret < certs_Tag_origlen) {
size_t certs_Tag_nlen = certs_Tag_olen + sizeof(*(((data)->certs)->val));
if (certs_Tag_olen > certs_Tag_nlen) { e = ASN1_OVERFLOW; goto fail; }
certs_Tag_olen = certs_Tag_nlen;
certs_Tag_tmp = realloc(((data)->certs)->val, certs_Tag_olen);
if (certs_Tag_tmp == NULL) { e = ENOMEM; goto fail; }
((data)->certs)->val = certs_Tag_tmp;
e = decode_heim_any(p, len, &((data)->certs)->val[((data)->certs)->len], &l);
if(e) goto fail;
p += l; len -= l; ret += l;
((data)->certs)->len++;
len = certs_Tag_origlen - ret;
}
ret += certs_Tag_oldret;
}
len = certs_oldlen - certs_datalen;
}
}
{
size_t crls_datalen, crls_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &crls_datalen, &l);
if(e) {
(data)->crls = NULL;
} else {
(data)->crls = calloc(1, sizeof(*(data)->crls));
if ((data)->crls == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
crls_oldlen = len;
if (crls_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = crls_datalen;
e = decode_heim_any(p, len, (data)->crls, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = crls_oldlen - crls_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_OriginatorInfo(data);
return e;
}

void
free_OriginatorInfo(OriginatorInfo *data)
{
if((data)->certs) {
while(((data)->certs)->len){
free_heim_any(&((data)->certs)->val[((data)->certs)->len-1]);
((data)->certs)->len--;
}
free(((data)->certs)->val);
((data)->certs)->val = NULL;
free((data)->certs);
(data)->certs = NULL;
}
if((data)->crls) {
free_heim_any((data)->crls);
free((data)->crls);
(data)->crls = NULL;
}
}

size_t
length_OriginatorInfo(const OriginatorInfo *data)
{
size_t ret = 0;
if((data)->certs){
size_t Top_tag_oldret = ret;
ret = 0;
{
int certs_tag_oldret = ret;
int i;
ret = 0;
for(i = ((data)->certs)->len - 1; i >= 0; --i){
int certs_tag_for_oldret = ret;
ret = 0;
ret += length_heim_any(&((data)->certs)->val[i]);
ret += certs_tag_for_oldret;
}
ret += certs_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->crls){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->crls);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_OriginatorInfo(const OriginatorInfo *from, OriginatorInfo *to)
{
memset(to, 0, sizeof(*to));
if((from)->certs) {
(to)->certs = malloc(sizeof(*(to)->certs));
if((to)->certs == NULL) goto fail;
if((((to)->certs)->val = malloc(((from)->certs)->len * sizeof(*((to)->certs)->val))) == NULL && ((from)->certs)->len != 0)
goto fail;
for(((to)->certs)->len = 0; ((to)->certs)->len < ((from)->certs)->len; ((to)->certs)->len++){
if(copy_heim_any(&((from)->certs)->val[((to)->certs)->len], &((to)->certs)->val[((to)->certs)->len])) goto fail;
}
}else
(to)->certs = NULL;
if((from)->crls) {
(to)->crls = malloc(sizeof(*(to)->crls));
if((to)->crls == NULL) goto fail;
if(copy_heim_any((from)->crls, (to)->crls)) goto fail;
}else
(to)->crls = NULL;
return 0;
fail:
free_OriginatorInfo(to);
return ENOMEM;
}

