/* Generated from ./k5.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <krb5_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_PA_ClientCanonicalized(unsigned char *p, size_t len, const PA_ClientCanonicalized *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* canon-checksum */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Checksum(p, len, &(data)->canon_checksum, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* names */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_PA_ClientCanonicalizedNames(p, len, &(data)->names, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_PA_ClientCanonicalized(const unsigned char *p, size_t len, PA_ClientCanonicalized *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t names_datalen, names_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &names_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
names_oldlen = len;
if (names_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = names_datalen;
e = decode_PA_ClientCanonicalizedNames(p, len, &(data)->names, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = names_oldlen - names_datalen;
}
{
size_t canon_checksum_datalen, canon_checksum_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &canon_checksum_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
canon_checksum_oldlen = len;
if (canon_checksum_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = canon_checksum_datalen;
e = decode_Checksum(p, len, &(data)->canon_checksum, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = canon_checksum_oldlen - canon_checksum_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_PA_ClientCanonicalized(data);
return e;
}

void
free_PA_ClientCanonicalized(PA_ClientCanonicalized *data)
{
free_PA_ClientCanonicalizedNames(&(data)->names);
free_Checksum(&(data)->canon_checksum);
}

size_t
length_PA_ClientCanonicalized(const PA_ClientCanonicalized *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_PA_ClientCanonicalizedNames(&(data)->names);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Checksum(&(data)->canon_checksum);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_PA_ClientCanonicalized(const PA_ClientCanonicalized *from, PA_ClientCanonicalized *to)
{
memset(to, 0, sizeof(*to));
if(copy_PA_ClientCanonicalizedNames(&(from)->names, &(to)->names)) goto fail;
if(copy_Checksum(&(from)->canon_checksum, &(to)->canon_checksum)) goto fail;
return 0;
fail:
free_PA_ClientCanonicalized(to);
return ENOMEM;
}

